<%

option explicit
	Dim objCommentXML
	Dim objRootElement
	Dim objRecord
	Dim objField
	Dim objFieldValue
	Dim objProcess
	Dim FileExists
	Dim objIPRecord
	Dim x
	Dim XMLFilePath
	Dim objRegExp, OutputSTR	
	Dim AbsCommentsDir
	Dim BannedArray
	Dim I
	Dim OwnerEmail	
	Dim DateFormat
	Dim DateOffset
	Dim BannedSubNet

'Set these variables appropriately	
'=-=-=-=-=-=--=-=-=-=-=-=-=-=
AbsCommentsDir = "/comments/" 'the directory of the server that the comments exist in
OwnerEmail = "email@domain.com" 'Your email address used to notify people when they've been banned
DateFormat = "mmmm-d h:mm" 'The date time format for the time display
DateOffset = 0 'If your webserver has a different time zone that the location of the blog, use this number to fix it.
BannedArray = Array("") 'Add banned IP's by editing this array. To ban the IP's of 127.0.0.1 and 10.0.0.1 you would edit the array to read Array("127.0.0.1","10.0.0.1")
'=-=-=-=-=-=--=-=-=-=-=-=-=-=
'end user defined variables

	for I = 0 to uBound(BannedArray)
		if Request.ServerVariables("REMOTE_ADDR") = BannedArray(I) then
			Response.Write "You have been banned. You may have abused the html functionality of the comments, or you may have been abusive or consistently off-topic. If you feel you have been wrongly banned contact <a href='mailto:" & OwnerEmail & "'>The Administrator</a>"
			Response.end
		end if
		I = I + 1
	next
	
Function strip(strRep)
	OutputSTR = strRep
	OutputSTR = replace(OutputSTR,"<script","")
	OutputSTR = replace(OutputSTR,"<!--","") 
	OutputSTR = replace(OutputSTR,".","&#46;") 
	OutputSTR = replace(OutputSTR,vbCRLF,"<br />")
	strip = trim(OutputSTR)
	Set objRegExp = Nothing
End Function

Function addComment(strFileName)
	Set objCommentXML = server.CreateObject("Microsoft.XMLDOM")
	objCommentXML.preserveWhiteSpace = True
	XMLFilePath = server.mappath(AbsCommentsDir) & "\" & strFileName & ".xml"
	FileExists = objCommentXML.Load(XMLFilePath)

	If FileExists = True Then
		Set objRootElement = objCommentXML.documentElement
	Else
		Set objRootElement = objCommentXML.createElement("Comments")
		objCommentXML.appendChild objRootElement

			Set objRecord = objCommentXML.createElement("FileName")
			objRecord.Text = strFileName
			objRootElement.appendChild objRecord
	End If
	

	
	Set objRecord = objCommentXML.createElement("comment")
	objRootElement.appendChild objRecord
	
	Set objIPRecord = objCommentXML.createElement("IPAddress")
	objIPRecord.Text = Request.ServerVariables("REMOTE_ADDR")
	objRecord.appendChild objIPRecord
	
	Set objIPRecord = objCommentXML.createElement("DateTime")
	objIPRecord.Text = replace(formatdatetime(Now, vbShortDate),"/",".") & " (" & dateadd("h",DateOffset,formatdatetime(Now, 4)) & ")"
	objRecord.appendChild objIPRecord
	
	For x = 1 To Request.Form.Count
		if request.form.key(x) = "CommentText" then
			if Request.Form(x) = "" then
				Set objField = Nothing
				Set objCommentXML = Nothing
				Set objFieldValue = Nothing
				Set objProcess = Nothing	
				Set objRootElement = Nothing
				Set objRecord = Nothing
				Set objIPRecord = Nothing
				Response.redirect("comments.asp?comment=" & Request.QueryString("comment"))
			end if
		end if
		If instr(1,Request.Form.Key(x),"btn") = 0 Then
			Set objField = objCommentXML.createElement(Request.Form.Key(x))
			
			If strip(Request.Form(x)) = "none" or strip(Request.Form(x)) = "" or strip(Request.Form(x)) = "http://" and Request.Form.Key(x) = "url" then
				objField.Text = ""
				objRecord.appendChild objField
			ElseIf strip(Request.Form(x)) <> "" then
				objField.Text = strip(Request.Form(x))
					if left(strip(Request.Form(x)),7) <> "http://" and Request.Form.Key(x) = "url" then
						objField.text = "http://" & strip(Request.Form(x))
					end if
				objRecord.appendChild objField
			end if
		End If
	Next 
	
	If FileExists = False then
		Set objProcess = objCommentXML.createProcessingInstruction("xml", "version='1.0'")
		objCommentXML.insertBefore objProcess, objCommentXML.childNodes(0)
	End If
	
	objCommentXML.save server.mappath(AbsCommentsDir) & "\" & strFileName & ".xml"
	
	Set objField = Nothing
	Set objCommentXML = Nothing
	Set objFieldValue = Nothing
	Set objProcess = Nothing	
	Set objRootElement = Nothing
	Set objRecord = Nothing
	Set objIpRecord = Nothing
End Function

'On Error Resume Next
addComment Request.QueryString("comment")
'Response.Write Request.QueryString("comment")
If err.number <> 0 and Request.QueryString("debug") <> "true" then
	Response.Write err.number & "<br>"
	Response.write("Errors occurred while saving your comment submission.")
Else
	Response.redirect("comments.asp?comment=" & Request.QueryString("comment"))
End If
%>

